% External References - NZ:P Mapping Documentation
# External References

## Introduction

*Nazi Zombies: Portable* is built using many open source, well-documented tools as well as a foundation of already well-understood game architecture. This has significant benefit, as a lot of general ground about creating content for *NZ:P* has already been covered by *Quake* and *Half-Life* mapping/modding resources.

The *Nazi Zombies: Portable* makes no attempt to document a lot of these concepts as a result. There are much better, more comprehensive resources that you should follow instead. These are linked below, using Internet Archive dumps where possible.

## Links

* [The Quake Wiki](https://quakewiki.org/wiki/Main_Page): Mega-Wiki of general Quake mapping, modding, and engine information. It is recommended to only follow the resources on this page that applies to vanilla Quake engines, as opposed to *FTE*, *Quakespasm*, or *DarkPlaces*, etc. *NZ:P* is not Quake but is built from a very vanilla baseline and features many entity compatibilities.
* [*"The Whole Half-Life"* Mapping Wiki](https://twhl.info/wiki/page/category%3AGoldsource_Tutorials%2BMapping): Wiki dedicated to *GoldSource* and *Half-Life* mapping. This should be referenced to understand only basic or fundamental concepts. *NZ:P* is not built from *Half-Life* but features some basic entities from GoldSource (such as `game_counter`) and uses *Half-Life* type `30` BSP.
* [TrenchBroom Manual](https://trenchbroom.github.io/manual/latest): The official online TrenchBroom manual.
* [Optimization - seedee](https://web.archive.org/web/20240503234130/https://gamebanana.com/tuts/13227): A GameBanana page giving a brief introduction of vis, portals, and leaves conceptually in GoldSource.
* [Optimization - Interlopers](https://web.archive.org/web/20240604033351/https://www.interlopers.net/optimization/index.php?chapter=intro): Very well-written series of pages explaining fundamental map optimization concepts.
* [TrenchBroom 2 Tutorials - dumptruck_ds (YouTube)](https://www.youtube.com/playlist?list=PLgDKRPte5Y0AZ_K_PZbWbgBAEt5xf74aE): A popular and comprehensive YouTube playlist introducing TrenchBroom and *Quake* mapping basics.
* [TrenchBroom and Quake - Slipseer (YouTuve)](https://www.youtube.com/playlist?list=PLdy0pXXA5D0_bt0oe9OcRuWPqrdyNX-KY): A YouTube playlist with more complex/advanced brush techniques to be followed in TrenchBroom.
* [Tutorial: Making textures with WadMaker (TWHL)](https://twhl.info/wiki/page/Tutorial%3A_Making_textures_with_WadMaker): Another *"The Whole Half-Life"* resource, for creating custom texture WADs. Many users would otherwise point to [*Wally*](https://valvedev.info/tools/wally/) however this application is closed-source and Windows exclusive.
* [ZHLT Command Reference](https://web.archive.org/web/20241007123643/http://zhlt.info/command-reference.html): Handbook on all of ZHLT/VHLT's supported command line arguments.